/*----------------------------------------------------------
	DirectX9HvO~O
		DirectX GraphicsTv

	SelectDevice.cpp
		uK؂ȃfoCXݒI郋[`v

	(C) 2003 NARITA, Takuro
		E-Mail	narita@a1.mbn.or.jp
--------------------------------------------------------------*/

#define STRICT				// ^`FbNɍsȂ
//#define WIN32_LEAN_AND_MEAN	// wb_[炠܂gȂ֐Ȃ
#define WINVER	0x040A		// Windows 98 & Windows 2000ȍ~

#include <windows.h>
#include <tchar.h>
#include <d3dx9.h>
#include <dxerr9.h>

#include "SelectDevice.h"

#define RELEASE(x)	if(x){x->Release();x=NULL;}

/*-------------------------------------------
	K؂Direct3DDevicetH[}bg̑I
--------------------------------------------*/
HRESULT SelectD3DDevice(UINT &Adapter, D3DDEVTYPE &Device)
{
	// A_v^̑I
	Adapter = D3DADAPTER_DEFAULT;	// vC}EfBXvCEA_v^

	// foCX\͂̎擾
	D3DCAPS9 Caps; // \͂󂯎D3DCAPS9\

	HRESULT hr;
	Device = D3DDEVTYPE_HAL;	// HALfoCX`FbN
	hr = g_pD3D->GetDeviceCaps(Adapter, Device, &Caps);
	if (FAILED(hr) || FAILED(CheckDeviceCaps(&Caps)))
	{
		DXTRACE_ERR("SelectD3DDevice CheckDeviceCaps HAL", E_FAIL);

		Device = D3DDEVTYPE_REF;	// REFfoCX`FbN
		hr = g_pD3D->GetDeviceCaps(Adapter, Device, &Caps);
		if (FAILED(hr) || FAILED(CheckDeviceCaps(&Caps)))
			return DXTRACE_ERR("SelectD3DDevice CheckDeviceCaps REF", E_FAIL);
	}

	// ݂̃fBXvC̃tH[}bgȂǂ擾Ă
	D3DDISPLAYMODE dmode;
	hr = g_pD3D->GetAdapterDisplayMode(D3DADAPTER_DEFAULT, &dmode);
	if (FAILED(hr))
		return DXTRACE_ERR("SelectD3DDevice GetAdapterDisplayMode", hr);

	// fBXvCƃobNEobt@̃tH[}bg̒
	hr = SelectAdapterFormat(Adapter, Device, dmode);
	if (FAILED(hr))
		return DXTRACE_ERR("SelectD3DDevice SelectAdapterFormat", hr);

	// [x/XeVEobt@̃tH[}bg̒
	if (g_fmtDepthStencil != D3DFMT_UNKNOWN)
	{
		hr = SelectDepthStencilFormat(Adapter, Device, dmode);
		if (FAILED(hr))
			return DXTRACE_ERR("SelectD3DDevice SelectDepthStencilFormat", hr);
	}

	// _OEeNX`̃tH[}bg𒲂ׂ
	hr = SelectRenderTexterFormat(Adapter, Device, dmode);
	if (FAILED(hr))
		return DXTRACE_ERR("SelectD3DDevice SelectRenderTexterFormat", hr);

	// ̑̃tH[}bg𒲂ׂ(Ȃ)

	// tV[EA`GCAVO𒲂ׂ
	hr = SelectMultiSampleType(Adapter, Device);
	if (FAILED(hr))
		return DXTRACE_ERR("SelectD3DDevice SelectMultiSampleType", hr);

	// fBXvCE[h𒲂ׂ
	hr = SelectDisplayMode(Adapter);
	if (FAILED(hr))
		return DXTRACE_ERR("SelectD3DDevice SelectDisplayMode", hr);

	return S_OK;
}

// foCX\͂̃`FbN
HRESULT CheckDeviceCaps(D3DCAPS9 *Caps)
{
	if (Caps->MaxStreams < 3)				// _Xg[
		return DXTRACE_ERR("CheckDeviceCaps MaxStreams < 3", E_FAIL);

	if (Caps->MaxPrimitiveCount < 0xFFFF)	// v~eBu
		return DXTRACE_ERR("CheckDeviceCaps MaxPrimitiveCount < 0xFFFF", E_FAIL);

	if (Caps->MaxVertexIndex < 0xFFFF)		// CfbNX
		return DXTRACE_ERR("CheckDeviceCaps MaxVertexIndex < 0xFFFF", E_FAIL);

	if (Caps->VertexShaderVersion < D3DVS_VERSION(2, 0))	// _VF[_Eo[W
		return DXTRACE_ERR("CheckDeviceCaps VertexShaderVersion < D3DVS_VERSION(2, 0)", E_FAIL);

	if (Caps->PixelShaderVersion < D3DPS_VERSION(2, 0))	// sNZEVF[_Eo[W
		return DXTRACE_ERR("CheckDeviceCaps PixelShaderVersion < D3DPS_VERSION(2, 0)", E_FAIL);

	return S_OK;
}

// fBXvCƃobNEobt@̃tH[}bg̒
HRESULT SelectAdapterFormat(UINT Adapter, D3DDEVTYPE Device, D3DDISPLAYMODE dmode)
{
	HRESULT hr = S_OK;

	// EChEE[h
	ZeroMemory(&g_D3DPPWindow, sizeof(g_D3DPPWindow));
	g_D3DPPWindow.BackBufferCount			= 1;
	g_D3DPPWindow.SwapEffect				= D3DSWAPEFFECT_DISCARD;
	g_D3DPPWindow.hDeviceWindow				= g_hWindow;
	g_D3DPPWindow.Windowed					= TRUE;
	g_D3DPPWindow.PresentationInterval		= g_Interval;

	for (int i=0; i< g_fmtDisplayNum; i++)
	{
		hr = g_pD3D->CheckDeviceType(Adapter, Device, dmode.Format, g_fmtDisplay[i], TRUE);
		if (SUCCEEDED(hr))
		{
			g_D3DPPWindow.BackBufferFormat = g_fmtDisplay[i];
			break;
		}
	}
	if (FAILED(hr))
		return DXTRACE_ERR("SelectAdapterFormat CheckDeviceType Window", hr);

	// tXN[E[h
	ZeroMemory(&g_D3DPPFull, sizeof(g_D3DPPFull));
	g_D3DPPFull.BackBufferCount				= 1;
	g_D3DPPFull.SwapEffect					= D3DSWAPEFFECT_DISCARD;
	g_D3DPPFull.hDeviceWindow				= g_hWindow;
	g_D3DPPFull.Windowed					= FALSE;
	g_D3DPPFull.PresentationInterval		= g_Interval;
	
	for (/*int */i=0; i< g_fmtDisplayNum; i++)
	{
		hr = g_pD3D->CheckDeviceType(Adapter, Device, g_fmtDisplay[i], g_fmtDisplay[i], FALSE);
		if (SUCCEEDED(hr))
		{
			g_D3DPPFull.BackBufferFormat = g_fmtDisplay[i];
			break;
		}
	}
	if (FAILED(hr))
		return DXTRACE_ERR("SelectAdapterFormat CheckDeviceType Full", hr);

	return S_OK;
}

// [x/XeVEobt@̃tH[}bg𒲂ׂ
HRESULT SelectDepthStencilFormat(UINT Adapter, D3DDEVTYPE Device, D3DDISPLAYMODE dmode)
{
	HRESULT hr;

	// EChEE[h
	hr = g_pD3D->CheckDeviceFormat(Adapter, Device,
				dmode.Format, D3DUSAGE_DEPTHSTENCIL, D3DRTYPE_SURFACE, g_fmtDepthStencil);
	if (FAILED(hr))
		return DXTRACE_ERR("SelectDepthStencilFormat CheckDeviceFormat DS Window", hr);

	hr = g_pD3D->CheckDepthStencilMatch(Adapter, Device,
				dmode.Format, g_D3DPPWindow.BackBufferFormat, g_fmtDepthStencil);
	if (FAILED(hr))
		return DXTRACE_ERR("SelectDepthStencilFormat CheckDepthStencilMatch DS Window", hr);

	g_D3DPPWindow.EnableAutoDepthStencil = TRUE;
	g_D3DPPWindow.AutoDepthStencilFormat = g_fmtDepthStencil;

	// tXN[E[h
	hr = g_pD3D->CheckDeviceFormat(Adapter, Device,
				g_D3DPPFull.BackBufferFormat, D3DUSAGE_DEPTHSTENCIL, D3DRTYPE_SURFACE, g_fmtDepthStencil);
	if (FAILED(hr))
		return DXTRACE_ERR("SelectDepthStencilFormat CheckDeviceFormat DS Full", hr);

	hr = g_pD3D->CheckDepthStencilMatch(Adapter, Device,
				g_D3DPPFull.BackBufferFormat, g_D3DPPFull.BackBufferFormat, g_fmtDepthStencil);
	if (FAILED(hr))
		return DXTRACE_ERR("SelectDepthStencilFormat CheckDepthStencilMatch DS Full", hr);

	g_D3DPPFull.EnableAutoDepthStencil = TRUE;
	g_D3DPPFull.AutoDepthStencilFormat = g_fmtDepthStencil;

	return S_OK;
}

// _OEeNX`̃tH[}bg𒲂ׂ
HRESULT SelectRenderTexterFormat(UINT Adapter, D3DDEVTYPE Device, D3DDISPLAYMODE dmode)
{
	HRESULT hr = S_OK;

	// EChEE[h
	g_fmtRendTexterWindow = D3DFMT_UNKNOWN;
	for (int i=0; i< g_fmtRendTexterNum; i++)
	{
		hr = g_pD3D->CheckDeviceFormat(Adapter, Device,
				dmode.Format, D3DUSAGE_RENDERTARGET, D3DRTYPE_TEXTURE, g_fmtRendTexter[i]);
		if (SUCCEEDED(hr))
		{
			hr = g_pD3D->CheckDepthStencilMatch(Adapter, Device,
						dmode.Format, g_fmtRendTexter[i], g_fmtDepthStencil);
			if (SUCCEEDED(hr))
			{
				g_fmtRendTexterWindow = g_fmtRendTexter[i];
				break;
			}
		}
	}
	if (FAILED(hr))
		return DXTRACE_ERR("SelectRenderTexterFormat Window", hr);

	// tXN[E[h
	g_fmtRendTexterFull = D3DFMT_UNKNOWN;
	for (/*int */i=0; i< g_fmtRendTexterNum; i++)
	{
		hr = g_pD3D->CheckDeviceFormat(Adapter, Device,
				g_D3DPPFull.BackBufferFormat,
				D3DUSAGE_RENDERTARGET, D3DRTYPE_TEXTURE, g_fmtRendTexter[i]);
		if (SUCCEEDED(hr))
		{
			hr = g_pD3D->CheckDepthStencilMatch(Adapter, Device,
					g_D3DPPFull.BackBufferFormat, g_fmtRendTexter[i], g_fmtDepthStencil);
			if (SUCCEEDED(hr))
			{
				g_fmtRendTexterFull = g_fmtRendTexter[i];
				break;
			}
		}
	}
	if (FAILED(hr))
		return DXTRACE_ERR("SelectRenderTexterFormat Full", hr);

	return S_OK;
}

// tV[EA`GCAVO𒲂ׂ
HRESULT SelectMultiSampleType(UINT Adapter, D3DDEVTYPE Device)
{
	// EChEE[h
	for (int i=0; i<g_MultiSampleTypeNum; i++)
	{
		if (FAILED(g_pD3D->CheckDeviceMultiSampleType(Adapter, Device,
				g_D3DPPWindow.BackBufferFormat, TRUE, g_MultiSampleType[i], NULL)))
			continue;
		if (g_D3DPPWindow.EnableAutoDepthStencil == TRUE)
			if (FAILED(g_pD3D->CheckDeviceMultiSampleType(Adapter, Device,
					g_D3DPPWindow.AutoDepthStencilFormat, TRUE, g_MultiSampleType[i], NULL)))
				continue;
		g_D3DPPWindow.MultiSampleType	= g_MultiSampleType[i];
		g_D3DPPWindow.MultiSampleQuality = 0;
		break;
	}

	// tXN[E[h
	for (/*int */i=0; i<g_MultiSampleTypeNum; i++)
	{
		if (FAILED(g_pD3D->CheckDeviceMultiSampleType(Adapter, Device,
				g_D3DPPFull.BackBufferFormat, FALSE, g_MultiSampleType[i], NULL)))
			continue;
		if (g_D3DPPWindow.EnableAutoDepthStencil == TRUE)
			if (FAILED(g_pD3D->CheckDeviceMultiSampleType(Adapter, Device,
					g_D3DPPFull.AutoDepthStencilFormat, FALSE, g_MultiSampleType[i], NULL)))
				continue;
		g_D3DPPFull.MultiSampleType	= g_MultiSampleType[i];
		g_D3DPPFull.MultiSampleQuality = 0;
		break;
	}

	return S_OK;
}

// fBXvCE[h𒲂ׂ
HRESULT SelectDisplayMode(UINT Adapter)
{
	// EChEE[h(ׂKvȂ)

	// tXN[E[h
	D3DDISPLAYMODE dmode = { 0, 0, 0, D3DFMT_UNKNOWN };
	int level = 1000000;
	int num = g_pD3D->GetAdapterModeCount(Adapter, g_D3DPPFull.BackBufferFormat);
	for (int i=0; i<num; i++)
	{
		// fBXvCE[h̗
		D3DDISPLAYMODE dm;
		g_pD3D->EnumAdapterModes(Adapter, g_D3DPPFull.BackBufferFormat, i, &dm);
		// ]̃[hƂ̌덷
		int l = abs(g_sizeFullMode.cx  - dm.Width) + abs(g_sizeFullMode.cy  - dm.Height);
		if (l < level)
		{
			// K؂ȃ[hI
			dmode = dm;
			level = l;
		}
	}
	if (dmode.Format == D3DFMT_UNKNOWN)
		return DXTRACE_ERR("SelectDisplayMode EnumAdapterModes", E_FAIL);

	g_D3DPPFull.BackBufferWidth  = dmode.Width;
	g_D3DPPFull.BackBufferHeight = dmode.Height;

	return S_OK;
}

